﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PIbd_22_Kalyshev_Y_V_MotorBoat_Base
{
    internal class DrawningSpeedboat : DrawningBoat
    {
        /// <summary>
        /// Инициализация свойств
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес автомобиля</param>
        /// <param name="bodyColor">Цвет кузова</param>
        /// <param name="dopColor">Дополнительный цвет</param>
        /// <param name="bodyKit">Признак наличия обвеса</param>
        /// <param name="wing">Признак наличия антикрыла</param>
        /// <param name="sportLine">Признак наличия гоночной полосы</param>
        public DrawningSpeedboat(int speed, float weight, Color bodyColor, Color dopColor, bool bodyKit, bool wing, bool sportLine) :
        base(speed, weight, bodyColor, 195, 80)
        {
            Boat = new EntitySpeedboat(speed, weight, bodyColor, dopColor, bodyKit, wing, sportLine);
        }
        public override void DrawTransport(Graphics g)
        {
            if (Boat is not EntitySpeedboat sportBoat)
            {
                return;
            }
            Pen pen = new(Color.Black);
            Brush baseBrush = new SolidBrush(sportBoat?.BodyColor ?? Color.Black);
            Brush dopBrush = new SolidBrush(sportBoat?.DopColor ?? Color.Black);
            _startPosX += 25;
            _startPosY += 10;
            base.DrawTransport(g);
            _startPosX -= 25;
            _startPosY -= 10;
            if (sportBoat.Wing)
            {
                g.FillRectangle(dopBrush, _startPosX, _startPosY, 20, 80);
                g.DrawRectangle(pen, _startPosX, _startPosY, 20, 80);
                g.FillRectangle(baseBrush, _startPosX + 20, _startPosY + 20, 10, 40);
                g.DrawRectangle(pen, _startPosX + 20, _startPosY + 20, 10, 40);
            }
            _startPosX += 25;
            _startPosY += 10;
            if (sportBoat.BodyKit)
            {
                PointF pt1 = new PointF(_startPosX + 120, _startPosY + 10);
                PointF pt2 = new PointF(_startPosX + 155, _startPosY + 30);
                PointF pt3 = new PointF(_startPosX + 120, _startPosY + 50);
                PointF pt4 = new PointF(_startPosX + 120, _startPosY + 45);
                PointF pt5 = new PointF(_startPosX + 145, _startPosY + 30);
                PointF pt6 = new PointF(_startPosX + 120, _startPosY + 15);
                g.FillPolygon(dopBrush, new PointF[] { pt1, pt2, pt3, pt4, pt5, pt6 });
            }
            if (sportBoat.SportLine)
            {
                PointF pt1 = new PointF(_startPosX + 70, _startPosY);
                PointF pt2 = new PointF(_startPosX + 80, _startPosY);
                PointF pt3 = new PointF(_startPosX + 120, _startPosY + 60);
                PointF pt4 = new PointF(_startPosX + 110, _startPosY + 60);
                g.FillPolygon(dopBrush, new PointF[] { pt1, pt2, pt3, pt4 });
                g.FillEllipse(new SolidBrush(Color.Brown), _startPosX + 10, _startPosY + 10, 110, 40);
            }
            _startPosX -= 25;
            _startPosY -= 10;
        }
    }
}
